sr	=  __SRATE
ksmps	=  __KSMPS
nchnls	=  2

/* reverb response generator v 1.2 */

#include "spat.h.orc"

	seed 0		/* initialize random seed */

i_	ftgen 64, 0, 4, -2, 0, 0, 0, 0		/* clear tables */
i_	ftgen 65, 0, 4, -2, 0, 0, 0, 0
i_	ftgen 66, 0, 4, -2, 0, 0, 0, 0

	instr 1		/* scheduler instr */

ilnth	=  (p4 < 0 ? ((int(0.5 - p4) + 0.25) / sr) : p4)	/* reverb */
ilnth	=  (ilnth < (1.25 / kr) ? (1.25 / kr) : ilnth)		/* length */
p3	=  ilnth

	kgoto rvb_init4
i1	=  ftlen(64)
	if (i1 < 16) igoto rvb_init1
	schedkwhen 1, -1, -1, 2, 0, p3, 64	/* old type reverb */
rvb_init1:
i1	=  ftlen(65)
	if (i1 < 8) igoto rvb_init2
	schedkwhen 1, -1, -1, 3, 0, p3, 65	/* 3D room */
rvb_init2:
i1	=  ftlen(66)
i2	=  0
rvb_init3:
	if (i2 > (i1 - 4.5)) igoto rvb_init4	/* new type reverb */
i3	table int(i2 + 0.5), 66		/* table number	*/
	if ((i3 < 67) || (i3 > 127) || (ftlen(i3) < 16)) igoto rvb_init4
i4	table int(i2 + 1.5), 66		/* volume	*/
i5	table int(i2 + 2.5), 66		/* azimuth	*/
i6	table int(i2 + 3.5), 66		/* elevation	*/
i7	table int(i2 + 4.5), 66		/* distance	*/
	schedkwhen 1, -1, -1, 4, 0, p3, i3, i4, i5, i6, i7
i2	=  i2 + 5
	igoto rvb_init3
rvb_init4:

	endin

	instr 2			/* ------ instr 2: old type reverb ------ */

ivol	table  0, p4	/* output volume			*/
idst	table  1, p4	/* distance				*/
iatt	table  2, p4	/* envelope attack			*/
ihld	table  3, p4	/* envelope hold time			*/
idens0	table  4, p4	/* start density			*/
idens1	table  5, p4	/* end density				*/
idnsenv	table  6, p4	/* envelope half-time			*/
iLPf0	table  7, p4	/* LP start frequency			*/
iLPf1	table  8, p4	/* LP end frequency			*/
iLPenv	table  9, p4	/* LP envelope half-time		*/
iHPf0	table 10, p4	/* HP start frequency			*/
iHPf1	table 11, p4	/* HP end frequency			*/
iHPenv	table 12, p4	/* HP envelope half-time		*/

ixx2	=  1 / 1024	/* start and end level = -60 dB		*/

kenv0	linseg 1.0, p3-0.05, 1.0, 0.05, 0.0, 1.0, 0.0	/* amp. envelope */
kenv1	expseg ixx2, iatt, 1.0, ihld, 1.0, p3 - (iatt + ihld), ixx2

kdens	port idens1, idnsenv, idens0		/* density */
kLPf	port iLPf1, iLPenv, iLPf0		/* LP filter frequency */
kHPf	port iHPf1, iHPenv, iHPf0		/* HP filter frequency */

aenv0	interp kenv0		/* convert k-rate envelopes to a-rate */
aenv1	interp kenv1
adens	interp kdens

aL	unirand 2.0				/* noise generator */
aR	unirand 2.0
aL	=  aL - 1.0
aR	=  aR - 1.0
aLx	limit (abs(aL) + adens - 1.0) * 1.0e24, 0.0, 1.0
aRx	limit (abs(aR) + adens - 1.0) * 1.0e24, 0.0, 1.0
aL	=  aL * aLx * aenv1
aR	=  aR * aRx * aenv1

a_	tone aL, kHPf				/* HP filter */
aL	=  aL - a_
a_	tone aR, kHPf
aR	=  aR - a_
aL	tone aL, kLPf				/* LP filter */
aR	tone aR, kLPf

i_d_	=  idst					/* distance */
i_el_	=  0.0					/* elevation */

axL	=  0
axR	=  0

a_	=  aL					/* left channel */
i_az_	=  -90.0
__SPAT1
axL	=  axL + a_L_
axR	=  axR + a_R_

a_	=  aR					/* right channel */
i_az_	=  90.0
__SPAT1
axL	=  axL + a_L_
axR	=  axR + a_R_

axL	butterlp ivol * axL, sr * 0.48
axR	butterlp ivol * axR, sr * 0.48

	outs axL * aenv0, axR * aenv0

	endin

	instr 3			/* -------- instr 3: 3D room -------- */

	kgoto room_perf

idep01	table  0, $ROOM_TABLE		/* save old depth and seed values */
idep02	table  1, $ROOM_TABLE
irseed	table  5, $ROOM_TABLE
ivol	table  0, p4			/* volume		*/
iazim	table  1, p4			/* azimuth		*/
ielev	table  2, p4			/* elevation		*/
idist	table  3, p4			/* distance		*/
imode	=  __MODE			/* spat3dt mode		*/
i_	table  4, p4			/* early refl. depth	*/
	if (i_ < -1) igoto room_init1
	tableiw i_, 0, $ROOM_TABLE
room_init1:
i_	table  5, p4			/* late refl. depth	*/
	if (i_ < -1) igoto room_init2
	tableiw i_, 1, $ROOM_TABLE
room_init2:
i_	table  6, p4			/* random seed		*/
	if (i_ < -1) igoto room_init3
	tableiw i_, 5, $ROOM_TABLE
room_init3:

imdst	=  0.001				/* set idist and imode for */
imdst	=  (imode == 4 ? $EARDIST : imdst)	/* spat3dt		   */
imdst	=  (imode == 2 ? $UNITDIST : imdst)
imode	=  (imode == 3 ? 2 : imode)		/* MODE = 3 is PhseStereo */

/* set up output table */

iflen	=  int(exp(log(2.0) * int(3.0 + (log(sr * p3) / log(2.0)))) + 0.5)
i_	ftgen 2, 0, iflen, -7, 0, iflen, 0

/* convert coordinates */

iX	=  sin(0.01745329 * iazim) * cos(0.01745329 * ielev) * idist
iY	=  cos(0.01745329 * iazim) * cos(0.01745329 * ielev) * idist
iZ	=  sin(0.01745329 * ielev) * idist

/* render IR */

	spat3dt 2, iX, iY, iZ, imdst, $ROOM_TABLE, imode, 0.01

	tableiw idep01, 0, $ROOM_TABLE	/* restore depth and seed values */
	tableiw idep02, 1, $ROOM_TABLE
	tableiw irseed, 5, $ROOM_TABLE

room_perf:

apos	line 0.0, 1.0, sr		/* read data from table */
a_1_	table apos * 4.0 + 0.25, 2
a_2_	table apos * 4.0 + 1.25, 2
a_3_	table apos * 4.0 + 2.25, 2
a_4_	table apos * 4.0 + 3.25, 2

iofs	=  1 / 1e30
a_1_	=  a_1_ + iofs
a_2_	=  a_2_ + iofs
a_3_	=  a_3_ + iofs
a_4_	=  a_4_ + iofs

__DECD1

aenv	linseg 1.0, p3 - 0.02, 1.0, 0.02, 0.0
	outs aenv * ivol * a_L_, aenv * ivol * a_R_

	endin

	instr 4			/* ------ instr 4: new type reverb ------ */

iatt	table  0, p4	/* envelope attack			*/
ihld	table  1, p4	/* envelope hold time			*/
idens0	table  2, p4	/* start density			*/
idens1	table  3, p4	/* end density				*/
idnsenv	table  4, p4	/* density envelope half-time		*/
iLPf0	table  5, p4	/* lowpass start frequency		*/
iLPf1	table  6, p4	/* lowpass end frequency		*/
iLPenv	table  7, p4	/* lowpass envelope half-time		*/
iHPf0	table  8, p4	/* highpass start frequency		*/
iHPf1	table  9, p4	/* highpass end frequency		*/
iHPenv	table 10, p4	/* highpass envelope half-time		*/

ivol	=  p5		/* volume				*/
iazim	=  p6		/* azimuth				*/
ielev	=  p7		/* elevation				*/
idist	=  p8		/* distance				*/

ixx2	=  1 / 1024	/* start and end level = -60 dB		*/

kenv0	linseg 1.0, p3-0.05, 1.0, 0.05, 0.0, 1.0, 0.0	/* amp. envelope */
kenv1	expseg ixx2, iatt, 1.0, ihld, 1.0, p3 - (iatt + ihld), ixx2

kdens	port idens1, idnsenv, idens0		/* density */
kLPf	port iLPf1, iLPenv, iLPf0		/* LP filter frequency */
kHPf	port iHPf1, iHPenv, iHPf0		/* HP filter frequency */

aenv0	interp kenv0		/* convert k-rate envelopes to a-rate */
aenv1	interp kenv1
adens	interp kdens

aL	unirand 2.0				/* noise generator */
aL	=  aL - 1.0
aLx	limit (abs(aL) + adens - 1.0) * 1.0e24, 0.0, 1.0
aL	=  aL * aLx * aenv1

a_	tone aL, kHPf				/* HP filter */
aL	=  aL - a_
aL	tone aL, kLPf				/* LP filter */

i_d_	=  idist				/* distance	*/
i_el_	=  ielev				/* elevation	*/
i_az_	=  iazim				/* azimuth	*/

a_	=  aL					/* input signal	*/

__SPAT1

axL	butterlp ivol * a_L_, sr * 0.48
axR	butterlp ivol * a_R_, sr * 0.48

	outs axL * aenv0, axR * aenv0

	endin

